var CL = typeof module != 'undefined' ? require('../coastline') : window.CL;

var bench = function* (ops) {
	
	var t, lastid;
	var start = function (c) {
		t = Date.now();
		lastid = CL().id;
	};
	var end = function (c) {
		var ms = Date.now() - t;
		var id = CL().id;
		console.log(Math.round(ops / ms * 1000) + ' ops/sec, ' + ms + 'ms, ' + (id - lastid) + ' cxs, ' + Math.round((id - lastid) / ops) + ' cxs/op');
	};
	
	var noop = function () {};
	var noopgen = function* () {};
	var noopfun = CL(noopgen);
	var noopobj = {
		noop: noopfun
	};
	var arr = new Array(ops);
	
	var i;
	
	console.log('Noop generator');
	start();
	for (i = 0; i < ops; i++) yield i;
	end();
	
	
	console.log('Yielding a noop generator (noopgen)');
	start();
	for (i = 0; i < ops; i++) yield noopgen();
	end();
	
	console.log('Yielding a noop generator fun (noopfun)');
	start();
	for (i = 0; i < ops; i++) yield noopfun();
	end();
	
	console.log('Yielding a noop generator method');
	start();
	for (i = 0; i < ops; i++) yield noopobj.noop();
	end();
	
	console.log('Each over array (noopgen)');
	start();
	yield CL.each(arr, noopgen);
	end();
	
	console.log('Each over array (noopfun)');
	start();
	yield CL.each(arr, noopfun);
	end();
	
	console.log('Parallel over array (noopgen)');
	start();
	yield CL.parallel(arr, noopgen);
	end();
	
	console.log('Set/get over single context');
	start();
	yield CL.run(function* () {
		for (i = 0; i < ops; i++) {
			CL.set('key', 'value');
			CL.get('key');
		}
	});
	end();
	
	console.log('Get over 10 contexts');
	start();
	yield CL.run(function* () {
		CL.set('key', 'value');
		var rec = function* (n) {
			if (n) return yield rec(n - 1);
			for (i = 0; i < ops; i++) {
				CL.get('key');
			}
		};
		yield rec(9);
	});
	end();
	
};

CL.run(function* () {
	console.log('DEBUG OFF');
	yield bench(1000000);
	CL.debug(true);
	console.log('DEBUG ON');
	yield bench(100000);
});
