'use strict';

var CL = typeof module != 'undefined' ? require('../coastline') : window.CL;

var rand = function () {
	return Math.round(Math.random() * 1000);
};

var Person = function (name) {
	this.name = name;
	this.sent = 0;
	this.received = 0;
	this.failed = 0;
};
Person.prototype = {

	send: CL.fun(function* (to, message) {
		console.log(this.name + ': sending', message, 'to', to.name);
		this.sent++;
		yield CL.sleep(rand());
		yield to.receive(this, message);
	}, {
		retry: function* () {
			console.log(this.name + ' encountered a deadlock');
			this.sent--;
			this.failed++;
		}
	}),
	
	receive: CL.fun(function* (from, message) {
		this.received++;
		yield CL.sleep(rand());
		console.log(this.name + ': received', message, 'from', from.name);
		if (message == 'Hello!') yield this.send(from, 'Hi!');
		else if (message == 'How are you?') yield this.send(from, 'Fine, thanks!');
		else if (message == 'Isn\'t the weather lovely today?') yield this.send(from, 'It is indeed!');
	}),
	
	report: CL.fun(function* () {
		console.log(this.name + ' sent', this.sent, 'messages, received', this.received, 'messages and failed', this.failed, 'times');
	})

};

CL.run(function* () {
	
	var alice = new Person('Alice');
	var bob = new Person('Bob');
	var carol = new Person('Carol');
	
	yield CL.wait([
		CL.bg(alice.send(bob, 'Hello!')),
		CL.bg(bob.send(carol, 'How are you?')),
		CL.bg(carol.send(alice, 'Isn\'t the weather lovely today?'))
	]);
	
	yield alice.report();
	yield bob.report();
	yield carol.report();
	
});