'use strict';

var CLT = require('../test');
var CL = CLT.CL;

module.exports = CL.run(function* () {
	
	var obj = {
		
		ok: 'okz',
	
		simple: function () {
			return this.ok;
		},
		
		clfun: CL.fun(function* () {
			return this.ok;
		}),
		
		yielded: CL.fun(function* () {
			return this.ok;
		}),
		
		attempter: CL.fun(function* () {
			return yield CL.try([this, 'failer'], [this, this.clfun]);
		}),
		
		failer: CL.fun(function* () {
			CL.throw('fail');
		}),
		
		returner: CL.fun(function* (ok) {
			return ok;
		})
		
	};
	
	CLT.eq('okz', yield CL.run([obj, 'simple']));
	CLT.eq('okz', yield CL.run([obj, obj.simple]));
	CLT.eq('okz', yield CL.run([obj, 'clfun']));
	CLT.eq('okz', yield CL.run([obj, obj.clfun]));
	
	CLT.eq('okz', yield CL.top([obj, 'simple']));
	CLT.eq('okz', yield CL.top([obj, obj.simple]));
	CLT.eq('okz', yield CL.top([obj, 'clfun']));
	CLT.eq('okz', yield CL.top([obj, obj.clfun]));
	
	CLT.eq('okz', yield CL.run([obj, 'attempter']));
	
	CLT.eq('okz', yield CL.run([obj, 'returner'], 'okz'));
	CLT.eq('okz', yield CL.env({}, [obj, 'returner'], 'okz'));
	
	return CLT.success;
	
});