'use strict';

var CLT = require('../test');
var CL = CLT.CL;

module.exports = CL.run(function* () {
	
	var rand = function () {
		return Math.round(Math.random() * 100);
	};
	
	var Class = function () {
		this.sent = 0;
		this.received = 0;
		this.failed = 0;
	};
	Class.prototype = {
	
		start: CL.fun(function* (to, message) {
			yield this.send(to, message);
		}, {
			retry: function* () {
				this.failed++;
			}
		}),
		
		send: CL.fun(function* (to, message) {
			this.sent++;
			yield CL.sleep(rand());
			yield to.receive(this, message);
		}, {
			retry: function* () {
				this.sent--;
			}
		}),
		
		receive: CL.fun(function* (from, message) {
			this.received++;
			yield CL.sleep(rand());
			if (message) this.send(from, message - 1);
		})
		
	};

	var objs = [new Class(), new Class(), new Class(), new Class(), new Class()];
	
	yield CL.run(function* () {
		for (var i = 0; i < objs.length; i++) {
			CL.bg(objs[i].start(objs[i+1] || objs[0], 3));
		}
	});
	
	var failed = 0;
	for (var i = 0; i < objs.length; i++) {
		var obj = objs[i];
		CLT.eq(obj.sent, 4);
		CLT.eq(obj.received, 4);
		failed += obj.failed;
	}
	CLT.eq(failed, 1);
	
	return CLT.success;
	
});