'use strict';

var CLT = require('../test');
var CL = CLT.CL;

module.exports = CL.run(function* () {
	
	CLT.eq('ok', CL.immediate(CL.run(function* () {
		return 'ok';
	})));
	
	CLT.assert(CL.immediate(CL.run(function* () {
		yield CL.sleep(100);
		return 'ok';
	})) instanceof CL.Context );
	
	var obj = {
		method: CL.fun(function* () {
			return 'ok';
		}),
		other: CL.fun(function* () {
			let ok = yield this.method();
			return ok;
		}),
		sleep: CL.fun(function* () {
			yield CL.sleep(100);
		}),
		multi: CL.fun(function* () {
			CL.immediate(oobj.sleep());
			CL.immediate(oobj.sleep());
		})
	};
	
	var oobj = {
		other: CL.fun(function* () {
			let ok = yield obj.method();
			return ok;
		}),
		sleep: CL.fun(function* () {
			yield obj.sleep();
		})
	};
	
	CLT.eq('ok', CL.immediate(obj.method()));
	CLT.eq('ok', CL.immediate(obj.other()));
	CLT.eq('ok', CL.immediate(oobj.other()));
	CLT.assert(CL.immediate(CL.run(function* () {
		yield obj.multi();
		return 'ok';
	})) instanceof CL.Context );
	
	return CLT.success;
	
}); 
