'use strict';

var CLT = require('../test');
var CL = CLT.CL;

module.exports = CL.run(function* () {

	var done = 0;
	var t0 = Date.now();
	
	var obj = {
		slow: CL.fun(function* () {
			yield CL.sleep(1000);
			done++;
		}),
		loose: CL.fun(function* () {
			yield CL.sleep(1000);
			done++;
		}, { loose: true })
	};
	
	yield obj.slow();
	var tasks = [];
	for (var i = 0; i < 5; i++) {
		tasks.push(CL.top(function* () { obj.loose() }));
	}
	yield obj.slow();
	yield CL.wait(tasks);
	
	CLT.eq(Math.round((Date.now() - t0) / 1000), 2);
	CLT.eq(done, 7);
	
	return CLT.success;
	
});