'use strict';

var CLT = require('../test');
var CL = CLT.CL;

module.exports = CL.run(function* () {
	
	var queue;
	var t0;
	var err;
	
	t0 = Date.now();
	queue = CL.queue();
	queue.push(CL.bg(CL.sleep(100)));
	queue.push(CL.bg(CL.sleep(100)));
	queue.push(CL.bg(CL.sleep(100)));
	yield queue.push(CL.bg(CL.sleep(100)));
	CLT.eq(Math.round((Date.now() - t0) / 100), 4);
	
	t0 = Date.now();
	queue = CL.queue({ limit: 2 });
	queue.push(CL.bg(CL.sleep(100)));
	queue.push(CL.bg(CL.sleep(100)));
	queue.push(CL.bg(CL.sleep(100)));
	yield queue.push(CL.bg(CL.sleep(100)));
	CLT.eq(Math.round((Date.now() - t0) / 100), 2);
	
	t0 = Date.now();
	queue = CL.queue({ limit: 2, sleep: 100 });
	queue.push(CL.bg(CL.sleep(100)));
	queue.push(CL.bg(CL.sleep(100)));
	queue.push(CL.bg(CL.sleep(100)));
	yield queue.push(CL.bg(CL.sleep(100)));
	CLT.eq(Math.round((Date.now() - t0) / 100), 3);
	
	t0 = Date.now();
	queue = CL.queue();
	yield CL.try(function* () {
		yield queue.push(function* () {
			yield CL.sleep(100);
			CL.throw('err');
		});
	}, function (e) {
		err = e.type;
	});
	yield queue.push(CL.sleep(100));
	CLT.eq(Math.round((Date.now() - t0) / 100), 2);
	CLT.eq(err, 'err');
	
	return CLT.success;
	
});