'use strict';

var CLT = require('../test');
var CL = CLT.CL;

module.exports = CL.run(function* () {

	var res = [];
	var t0 = Date.now();
	
	var a = {
		start: CL(function* (x) {
			res.push('s');
			yield b.continue(this, x);
			res.push('f');
		}),
		decr: CL(function* (x) {
			res.push(x);
			yield b.continue(this, x - 1);
			res.push(x);
		}),
		finish: CL(function* (x) {
			res.push(x);
		})
	};
	var b = {
		continue: CL(function* (a, x) {
			yield CL.sleep(100);
			if (x) yield a.decr(x);
			else yield a.finish(x);
		})
	};
	
	var a1 = Object.create(a);
	var a2 = Object.create(a);
	
	yield a1.start(5);
	
	yield function* () {
		CL.bg(a1.start(2));
		CL.bg(a2.start(2));
	};
	
	/*
		The first call starts and counts 5 to 0 and back, then finished.
		Then second calls are both enqueued and start, but since they use the same 'b' they continue one after the other.
	 */
	CLT.eq(res, ['s', 5, 4, 3, 2, 1, 0, 1, 2, 3, 4, 5, 'f', 's', 's', 2, 1, 0, 1, 2, 'f', 2, 1, 0, 1, 2, 'f']);
	
	/*
		Should sleep a total of 5 + 1 + (2 + 1) * 2 == 12 times.
	 */
	CLT.eq(Math.round((Date.now() - t0) / 100), 12);
	
	return CLT.success;
	
});