'use strict';

var CLT = require('../test');
var CL = CLT.CL;

module.exports = CL.run(function* () {
	
	var res;
	
	var fun = function* () {
		return CL.val(CL.top(function* () { return 123; }));
	};
	res = yield fun();
	CLT.assert(res instanceof CL.Context);
	CLT.eq(yield res, 123);
	
	var wrap = CL.fun(function* () {
		var fun = function* () {
			return CL.val(CL.top(function* () { return 123; }));
		};
		return CL.val(yield fun());
	});
	res = yield fun();
	CLT.eq(yield res, 123);
	
	var arr = [yield wrap(), wrap(), CL.val(wrap())];
	yield CL.wait(arr);
	CLT.eq(arr[0], 123);
	CLT.assert(arr[1] instanceof CL.Context);
	CLT.eq(yield arr[1], 123);
	CLT.assert(arr[2] instanceof CL.Value);
	CLT.assert(arr[2].value instanceof CL.Context);
	
	return CLT.success;
	
});
